#
# Xenomai Real-Time System
#
# Copyright (c) Siemens AG, 2019
#
# Authors:
#  Quirin Gylstorff <quirin.gylstorff@siemens.com>
#
# SPDX-License-Identifier: MIT
#
device_type: qemu
job_name: QEMU pipeline, xenomai-images-qemu-arm64

timeouts:
  job:
    minutes: 90
  action:
    minutes: 65
  connection:
    minutes: 5
priority: medium
visibility: public

# context allows specific values to be overridden or included
context:
  # tell the qemu template which architecture is being tested
  # the template uses that to ensure that qemu-system-x86_64 is executed.
  arch: arm64
  extra_options:
  - -cpu cortex-a57
  - -global virtio-blk-device.scsi=off
  - -smp 2
  - -device virtio-serial-device
  - -device virtconsole,chardev=con
  - -chardev vc,id=con
  - -device virtio-blk-device,drive=disk
  - -device virtio-net-pci,netdev=net
  - -netdev user,id=net
  guestfs_interface: virtio
metadata:
  # please change these fields when modifying this job for your own tests.
  docs-source: xenomai-qemu-arm64
  docs-filename: qemu-pipeline-xenomai-arm64

# ACTION_BLOCK
actions:
- deploy:
    timeout:
      minutes: 15
    to: tmpfs
    images:
      kernel:
        image_arg: -kernel {kernel} -append "root=/dev/vda"
        url: ${DEPLOY_URL}/${ISAR_IMAGE}-${ISAR_DISTRIBUTION}-${TARGET}-vmlinuz
      initrd:
        image_arg: -initrd {initrd}
        url: ${DEPLOY_URL}/${ISAR_IMAGE}-${ISAR_DISTRIBUTION}-${TARGET}-initrd.img
      rootfs:
        image_arg: -drive file={rootfs},discard=unmap,if=none,id=disk,format=raw
        url: ${DEPLOY_URL}/${ISAR_IMAGE}-${ISAR_DISTRIBUTION}-${TARGET}.ext4.img.gz
        compression: gz
# BOOT_BLOCK
- boot:
    timeout:
      minutes: 15
    method: qemu
    media: tmpfs
    prompts: ["root@demo:"]
    auto_login:
      login_prompt: 'demo login:'
      username: root
      password_prompt: 'Password:'
      password: root

- test:
    timeout:
      minutes: 30
    definitions:
    - repository: http://git.linaro.org/lava-team/lava-functional-tests.git
      from: git
      path: lava-test-shell/smoke-tests-basic.yaml
      name: smoke-tests
    - repository:
        metadata:
          format: Lava-Test Test Definition 1.0
          name: xenomai-test-suite
          description: "runs the xenomai smokey test suite"
          maintainer:
            - quirin.gylstorff@siemens.org
        run:
          steps:
            - lava-test-case xenomai-smokey --shell xeno-test -k --vm
      from: inline
      path: inline/xenomai-test-suite.yaml
      name: xenomai-test-suite
